PROGRAM Biingpatch;

USES Dos;

CONST Stelle = $4BCA; {Ab Anfang Birpo.exe Patchstelle}
      Temp='temp.tmp';
      Patchtext='patch.txt';
      Orig='bipro.exe';

PROCEDURE Error;

BEGIN
  WriteLn('Usage : '+ParamStr(0)+#13#10
  +'-p fr Blutorganbank teuer'#13#10
  +'-n fr Blutorganbank umsonst'#13#10
  +'-u zum restaurieren (unpatch)');
  Halt(1);
END;

PROCEDURE Unpatch;

VAR input,Ziel : FILE;
      patchdatei   : Text;
      Buf : ARRAY [0..53999] OF Byte;
      Count : Word;

BEGIN
  Assign(input,Orig);
  {$i-}
  Reset(input,1);
  {$i+}
  IF IOResult>0 THEN
  BEGIN
    WriteLn(Orig+' wurde nicht gefunden !');
    Error;
  END;
  Assign(patchdatei,Patchtext);
  {$i-}
  Reset(patchdatei);
  {$i+}
  IF IOResult>0 THEN
  BEGIN
    WriteLn(Patchtext+' wurde nicht gefunden !');
    Error;
  END;
  Assign(Ziel,Temp);
  Rewrite(Ziel,1);
  BlockRead(input,Buf,SizeOf(Buf),Count);
  ReadLn(patchdatei,Buf[Stelle]);
  ReadLn(patchdatei,Buf[Stelle+1]);
  Close(patchdatei);
  BlockWrite(Ziel,Buf,Count);
  WHILE NOT Eof(input) DO
  BEGIN
    BlockRead(input,Buf,SizeOf(Buf),Count);
    BlockWrite(Ziel,Buf,Count);
  END;
  Close(input);
  Close(Ziel);
  Erase(input);
  Rename(Ziel,Orig);
  WriteLn('Restaurierung erfolgreich !');
  Halt(0);
END;

PROCEDURE Patch(Val : Byte);

VAR   input,Ziel : FILE;
      patchdatei : Text;
      Buf        : ARRAY [0..52999] OF Byte;
      Count      : Word;
      Open       : Boolean;
      message    : String[20];

BEGIN
  Assign(input,Orig);
  {$i-}
  Reset(input,1);
  IF IOResult>0 THEN
  BEGIN
    WriteLn(Orig+' wurde nicht gefunden !');
    Error;
  END;
  Assign(patchdatei,Patchtext);
  Reset(patchdatei);
  Open:=IOResult=0;
  IF NOT Open THEN Rewrite(patchdatei);
  Assign(Ziel,Temp);
  {$i+}
  Rewrite(Ziel,1);
  BlockRead(input,Buf,SizeOf(Buf),Count);
  IF NOT Open THEN
  BEGIN
    WriteLn(patchdatei,Buf[Stelle]);
    WriteLn(patchdatei,Buf[Stelle+1]);
  END;
  Close(patchdatei);
  Buf[Stelle]:=Val;
  Buf[Stelle+1]:=Val;
  BlockWrite(Ziel,Buf,Count);
  WHILE NOT Eof(input) DO
  BEGIN
    BlockRead(input,Buf,SizeOf(Buf),Count);
    BlockWrite(Ziel,Buf,Count);
  END;
  Close(input);
  Close(Ziel);
  Erase(input);
  Rename(Ziel,Orig);
  if val=0 then message:='auf 0' else message:='auf 65535';
  WriteLn('Patch '+message+' Lmmel erfolgreich !');
  Halt(0);
END;

BEGIN
  IF ParamCount=0 THEN Error;
  IF (ParamStr(1)='-p') OR (ParamStr(1)='-P') THEN Patch(255);
  IF (ParamStr(1)='-n') OR (ParamStr(1)='-N') THEN Patch(0);
  IF (ParamStr(1)='-u') OR (ParamStr(1)='-U') THEN Unpatch;
  Error;
END.
